#if !defined(RANDCW_H)
#define RANDCW_H

#include <deccw.h>
#include <inttcw.h>

#if defined(__cplusplus)
extern "C" {
#endif

#if defined(__COMPILER_KCC__)
#define HAVE_SHORT_NAMES	1
#endif

#if (!defined(HAVE_LONG_LONG_INT)) && ((__STDC_VERSION__ + 0) >= 199901)
#define HAVE_LONG_LONG_INT	1
#endif

#if defined(HAVE_SHORT_NAMES)
#define __STDC_VERSION__	0	/* to eliminate compiler warnings */

#include <shrtcw.h>

#endif /* defined(HAVE_SHORT_NAMES) */

typedef UINT_LEAST32_T randcw_state_t[4];

/* All function names are parenthesized to inhibit macro expansion
   that introduces conflicts with system header files on some
   systems. */

extern void (gscw) (/*@out@*/ randcw_state_t);
extern void (sscw) (const randcw_state_t);
extern void (incw_r) (/*@out@*/ randcw_state_t, UINT_LEAST32_T seed);

static const UINT_LEAST32_T LRANDCW_MAX = (UINT_LEAST32_T)0xffffffffL;

extern UINT_LEAST32_T (lrancw)(void);
extern UINT_LEAST32_T (lrancw_r)(/*@out@*/ randcw_state_t);
extern UINT_LEAST32_T (lrincw)(UINT_LEAST32_T, UINT_LEAST32_T);
extern UINT_LEAST32_T (lrincw_r)(/*@out@*/ randcw_state_t, UINT_LEAST32_T, UINT_LEAST32_T);
extern void (vlrancw) (int, /*@out@*/ UINT_LEAST32_T []);
extern void (vlrancw_r)(/*@out@*/ randcw_state_t, int, /*@out@*/ UINT_LEAST32_T []);
extern void (vlrincw) (int, /*@out@*/ UINT_LEAST32_T [], UINT_LEAST32_T, UINT_LEAST32_T);
extern void (vlrincw_r)(/*@out@*/ randcw_state_t, int, /*@out@*/ UINT_LEAST32_T [], UINT_LEAST32_T, UINT_LEAST32_T);

#if defined(HAVE_UINT_LEAST64_T)

static const UINT_LEAST64_T LLRANDCW_MAX = (UINT_LEAST64_T)0xffffffffffffffffLL;
extern UINT_LEAST64_T (llrancw)(void);
extern UINT_LEAST64_T (llrancw_r)(/*@out@*/ randcw_state_t);
extern UINT_LEAST64_T (llrincw)(UINT_LEAST64_T, UINT_LEAST64_T);
extern UINT_LEAST64_T (llrincw_r)(/*@out@*/ randcw_state_t, UINT_LEAST64_T, UINT_LEAST64_T);
extern void (vllrancw)(int, /*@out@*/ UINT_LEAST64_T []);
extern void (vllrancw_r)(/*@out@*/ randcw_state_t, int, /*@out@*/ UINT_LEAST64_T []);
extern void (vllrincw)(int, /*@out@*/ UINT_LEAST64_T [], UINT_LEAST64_T, UINT_LEAST64_T);
extern void (vllrincw_r)(/*@out@*/ randcw_state_t, int, /*@out@*/ UINT_LEAST64_T [], UINT_LEAST64_T, UINT_LEAST64_T);

#endif /* defined(HAVE_UINT_LEAST64_T) */

UINT_LEAST32_T (srancw)(UINT_LEAST32_T);

extern unsigned int (mscw)(void);
extern UINT_LEAST32_T (lmscw)(void);

#if defined(HAVE_UINT_LEAST64_T)

extern UINT_LEAST64_T (llmscw)(void);

#endif

extern int (sccw)(void);

extern float (ercwf)(void);
extern float (lrcwf)(float, float);
extern float (nrcwf)(void);
extern float (urcwf)(void);
extern float (urcw1f)(void);
extern float (urcw2f)(void);
extern float (urcw3f)(void);
extern float (urcw4f)(void);
extern void (vercwf)(int, float []);
extern void (vlrcwf)(int, float [], float, float);
extern void (vnrcwf)(int, float []);
extern void (vurcw1f)(int, float []);
extern void (vurcw2f)(int, float []);
extern void (vurcw3f)(int, float []);
extern void (vurcw4f)(int, float []);
extern void (vurcwf)(int, float []);

extern float (ercwf_r)(/*@out@*/ randcw_state_t);
extern float (lrcwf_r)(/*@out@*/ randcw_state_t, float, float);
extern float (nrcwf_r)(/*@out@*/ randcw_state_t);
extern float (urcwf_r)(/*@out@*/ randcw_state_t);
extern float (urcw1f_r)(/*@out@*/ randcw_state_t);
extern float (urcw2f_r)(/*@out@*/ randcw_state_t);
extern float (urcw3f_r)(/*@out@*/ randcw_state_t);
extern float (urcw4f_r)(/*@out@*/ randcw_state_t);
extern void (vercwf_r)(/*@out@*/ randcw_state_t, int, float []);
extern void (vlrcwf_r)(/*@out@*/ randcw_state_t, int, float [], float, float);
extern void (vnrcwf_r)(/*@out@*/ randcw_state_t, int, float []);
extern void (vurcw1f_r)(/*@out@*/ randcw_state_t, int, float []);
extern void (vurcw2f_r)(/*@out@*/ randcw_state_t, int, float []);
extern void (vurcw3f_r)(/*@out@*/ randcw_state_t, int, float []);
extern void (vurcw4f_r)(/*@out@*/ randcw_state_t, int, float []);
extern void (vurcwf_r)(/*@out@*/ randcw_state_t, int, float []);

extern double (ercw)(void);
extern double (lrcw)(double, double);
extern double (nrcw)(void);
extern double (urcw)(void);
extern double (urcw1)(void);
extern double (urcw2)(void);
extern double (urcw3)(void);
extern double (urcw4)(void);
extern void (vercw)(int, double []);
extern void (vlrcw)(int, double [], double, double);
extern void (vnrcw)(int, double []);
extern void (vurcw)(int, double []);
extern void (vurcw1)(int, double []);
extern void (vurcw2)(int, double []);
extern void (vurcw3)(int, double []);
extern void (vurcw4)(int, double []);

extern double (ercw_r)(/*@out@*/ randcw_state_t);
extern double (lrcw_r)(/*@out@*/ randcw_state_t, double, double);
extern double (nrcw_r)(/*@out@*/ randcw_state_t);
extern double (urcw_r)(/*@out@*/ randcw_state_t);
extern double (urcw1_r)(/*@out@*/ randcw_state_t);
extern double (urcw2_r)(/*@out@*/ randcw_state_t);
extern double (urcw3_r)(/*@out@*/ randcw_state_t);
extern double (urcw4_r)(/*@out@*/ randcw_state_t);
extern void (vercw_r)(/*@out@*/ randcw_state_t, int, double []);
extern void (vlrcw_r)(/*@out@*/ randcw_state_t, int, double [], double, double);
extern void (vnrcw_r)(/*@out@*/ randcw_state_t, int, double []);
extern void (vurcw1_r)(/*@out@*/ randcw_state_t, int, double []);
extern void (vurcw2_r)(/*@out@*/ randcw_state_t, int, double []);
extern void (vurcw3_r)(/*@out@*/ randcw_state_t, int, double []);
extern void (vurcw4_r)(/*@out@*/ randcw_state_t, int, double []);
extern void (vurcw_r)(/*@out@*/ randcw_state_t, int, double []);

#if defined(HAVE_LONG_DOUBLE)

extern long double (ercwl)(void);
extern long double (lrcwl)(long double, long double);
extern long double (nrcwl)(void);
extern long double (urcwl)(void);
extern long double (urcw1l)(void);
extern long double (urcw2l)(void);
extern long double (urcw3l)(void);
extern long double (urcw4l)(void);
extern void (vercwl)(int, long double []);
extern void (vlrcwl)(int, long double [], long double, long double);
extern void (vnrcwl)(int, long double []);
extern void (vurcw1l)(int, long double []);
extern void (vurcw2l)(int, long double []);
extern void (vurcw3l)(int, long double []);
extern void (vurcw4l)(int, long double []);
extern void (vurcwl)(int, long double []);

extern long double (ercwl_r)(/*@out@*/ randcw_state_t);
extern long double (lrcwl_r)(/*@out@*/ randcw_state_t, long double, long double);
extern long double (nrcwl_r)(/*@out@*/ randcw_state_t);
extern long double (urcwl_r)(/*@out@*/ randcw_state_t);
extern long double (urcw1l_r)(/*@out@*/ randcw_state_t);
extern long double (urcw2l_r)(/*@out@*/ randcw_state_t);
extern long double (urcw3l_r)(/*@out@*/ randcw_state_t);
extern long double (urcw4l_r)(/*@out@*/ randcw_state_t);
extern void (vercwl_r)(/*@out@*/ randcw_state_t, int, long double []);
extern void (vlrcwl_r)(/*@out@*/ randcw_state_t, int, long double [], long double, long double);
extern void (vnrcwl_r)(/*@out@*/ randcw_state_t, int, long double []);
extern void (vurcw1l_r)(/*@out@*/ randcw_state_t, int, long double []);
extern void (vurcw2l_r)(/*@out@*/ randcw_state_t, int, long double []);
extern void (vurcw3l_r)(/*@out@*/ randcw_state_t, int, long double []);
extern void (vurcw4l_r)(/*@out@*/ randcw_state_t, int, long double []);
extern void (vurcwl_r)(/*@out@*/ randcw_state_t, int, long double []);

#endif /* defined(HAVE_LONG_DOUBLE) */

#if defined(HAVE_LONG_LONG_DOUBLE)

extern long_long_double (ercwll)(void);
extern long_long_double (lrcwll)(long_long_double, long_long_double);
extern long_long_double (nrcwll)(void);
extern long_long_double (urcwll)(void);
extern long_long_double (urcw1ll)(void);
extern long_long_double (urcw2ll)(void);
extern long_long_double (urcw3ll)(void);
extern long_long_double (urcw4ll)(void);
extern void (vercwll)(int, long_long_double []);
extern void (vlrcwll)(int, long_long_double [], long_long_double, long_long_double);
extern void (vnrcwll)(int, long_long_double []);
extern void (vurcw1ll)(int, long_long_double []);
extern void (vurcw2ll)(int, long_long_double []);
extern void (vurcw3ll)(int, long_long_double []);
extern void (vurcw4ll)(int, long_long_double []);
extern void (vurcwll)(int, long_long_double []);

extern long_long_double (ercwll_r)(/*@out@*/ randcw_state_t);
extern long_long_double (lrcwll_r)(/*@out@*/ randcw_state_t, long_long_double, long_long_double);
extern long_long_double (nrcwll_r)(/*@out@*/ randcw_state_t);
extern long_long_double (urcwll_r)(/*@out@*/ randcw_state_t);
extern long_long_double (urcw1ll_r)(/*@out@*/ randcw_state_t);
extern long_long_double (urcw2ll_r)(/*@out@*/ randcw_state_t);
extern long_long_double (urcw3ll_r)(/*@out@*/ randcw_state_t);
extern long_long_double (urcw4ll_r)(/*@out@*/ randcw_state_t);
extern void (vercwll_r)(/*@out@*/ randcw_state_t, int, long_long_double []);
extern void (vlrcwll_r)(/*@out@*/ randcw_state_t, int, long_long_double [], long_long_double, long_long_double);
extern void (vnrcwll_r)(/*@out@*/ randcw_state_t, int, long_long_double []);
extern void (vurcw1ll_r)(/*@out@*/ randcw_state_t, int, long_long_double []);
extern void (vurcw2ll_r)(/*@out@*/ randcw_state_t, int, long_long_double []);
extern void (vurcw3ll_r)(/*@out@*/ randcw_state_t, int, long_long_double []);
extern void (vurcw4ll_r)(/*@out@*/ randcw_state_t, int, long_long_double []);
extern void (vurcwll_r)(/*@out@*/ randcw_state_t, int, long_long_double []);

#endif /* defined(HAVE_LONG_LONG_DOUBLE) */

#if defined(__ia64) && defined(__hpux) && defined(_FPWIDETYPES)

/* NB: _FPWIDETYPES is set by the HP-UX IA-64 compilers in response to
   the -fpwidetypes command-line option */

/* Mimic the HP-UX practice in <float.h>, <math.h>, and <stdlib.h> of
   providing typedefs of the user types extended and quad if they are
   not yet defined. */

#ifndef _INCLUDE_QUAD
typedef __float128 quad;
#define _INCLUDE_QUAD
#endif

#ifndef _INCLUDE_EXTENDED
typedef __float80 extended;
#define _INCLUDE_EXTENDED
#endif

extern __float80 (ercww)(void);
extern __float80 (lrcww)(__float80, __float80);
extern __float80 (nrcww)(void);
extern __float80 (urcww)(void);
extern __float80 (urcw1w)(void);
extern __float80 (urcw2w)(void);
extern __float80 (urcw3w)(void);
extern __float80 (urcw4w)(void);
extern void (vercww)(int, __float80 []);
extern void (vlrcww)(int, __float80 [], __float80, __float80);
extern void (vnrcww)(int, __float80 []);
extern void (vurcw1w)(int, __float80 []);
extern void (vurcw2w)(int, __float80 []);
extern void (vurcw3w)(int, __float80 []);
extern void (vurcw4w)(int, __float80 []);
extern void (vurcww)(int, __float80 []);

extern __float80 (ercww_r)(/*@out@*/ randcw_state_t);
extern __float80 (lrcww_r)(/*@out@*/ randcw_state_t, __float80, __float80);
extern __float80 (nrcww_r)(/*@out@*/ randcw_state_t);
extern __float80 (urcww_r)(/*@out@*/ randcw_state_t);
extern __float80 (urcw1w_r)(/*@out@*/ randcw_state_t);
extern __float80 (urcw2w_r)(/*@out@*/ randcw_state_t);
extern __float80 (urcw3w_r)(/*@out@*/ randcw_state_t);
extern __float80 (urcw4w_r)(/*@out@*/ randcw_state_t);
extern void (vercww_r)(/*@out@*/ randcw_state_t, int, __float80 []);
extern void (vlrcww_r)(/*@out@*/ randcw_state_t, int, __float80 [], __float80, __float80);
extern void (vnrcww_r)(/*@out@*/ randcw_state_t, int, __float80 []);
extern void (vurcw1w_r)(/*@out@*/ randcw_state_t, int, __float80 []);
extern void (vurcw2w_r)(/*@out@*/ randcw_state_t, int, __float80 []);
extern void (vurcw3w_r)(/*@out@*/ randcw_state_t, int, __float80 []);
extern void (vurcw4w_r)(/*@out@*/ randcw_state_t, int, __float80 []);
extern void (vurcww_r)(/*@out@*/ randcw_state_t, int, __float80 []);

extern __float128 (ercwq)(void);
extern __float128 (lrcwq)(__float128, __float128);
extern __float128 (nrcwq)(void);
extern __float128 (urcwq)(void);
extern __float128 (urcw1q)(void);
extern __float128 (urcw2q)(void);
extern __float128 (urcw3q)(void);
extern __float128 (urcw4q)(void);
extern void (vercwq)(int, __float128 []);
extern void (vlrcwq)(int, __float128 [], __float128, __float128);
extern void (vnrcwq)(int, __float128 []);
extern void (vurcw1q)(int, __float128 []);
extern void (vurcw2q)(int, __float128 []);
extern void (vurcw3q)(int, __float128 []);
extern void (vurcw4q)(int, __float128 []);
extern void (vurcwq)(int, __float128 []);

extern __float128 (ercwq_r)(/*@out@*/ randcw_state_t);
extern __float128 (lrcwq_r)(/*@out@*/ randcw_state_t, __float128, __float128);
extern __float128 (nrcwq_r)(/*@out@*/ randcw_state_t);
extern __float128 (urcwq_r)(/*@out@*/ randcw_state_t);
extern __float128 (urcw1q_r)(/*@out@*/ randcw_state_t);
extern __float128 (urcw2q_r)(/*@out@*/ randcw_state_t);
extern __float128 (urcw3q_r)(/*@out@*/ randcw_state_t);
extern __float128 (urcw4q_r)(/*@out@*/ randcw_state_t);
extern void (vercwq_r)(/*@out@*/ randcw_state_t, int, __float128 []);
extern void (vlrcwq_r)(/*@out@*/ randcw_state_t, int, __float128 [], __float128, __float128);
extern void (vnrcwq_r)(/*@out@*/ randcw_state_t, int, __float128 []);
extern void (vurcw1q_r)(/*@out@*/ randcw_state_t, int, __float128 []);
extern void (vurcw2q_r)(/*@out@*/ randcw_state_t, int, __float128 []);
extern void (vurcw3q_r)(/*@out@*/ randcw_state_t, int, __float128 []);
extern void (vurcw4q_r)(/*@out@*/ randcw_state_t, int, __float128 []);
extern void (vurcwq_r)(/*@out@*/ randcw_state_t, int, __float128 []);

#endif /* defined(__ia64) && defined(__hpux) && defined(_FPWIDETYPES) */

#if defined(HAVE_DECIMAL)

extern decimal_float (ercwdf)(void);
extern decimal_float (lrcwdf)(decimal_float, decimal_float);
extern decimal_float (nrcwdf)(void);
extern decimal_float (urcwdf)(void);
extern decimal_float (urcw1df)(void);
extern decimal_float (urcw2df)(void);
extern decimal_float (urcw3df)(void);
extern decimal_float (urcw4df)(void);
extern void (vercwdf)(int, decimal_float []);
extern void (vlrcwdf)(int, decimal_float [], decimal_float, decimal_float);
extern void (vnrcwdf)(int, decimal_float []);
extern void (vurcw1df)(int, decimal_float []);
extern void (vurcw2df)(int, decimal_float []);
extern void (vurcw3df)(int, decimal_float []);
extern void (vurcw4df)(int, decimal_float []);
extern void (vurcwdf)(int, decimal_float []);

extern decimal_float (ercwdf_r)(/*@out@*/ randcw_state_t);
extern decimal_float (lrcwdf_r)(/*@out@*/ randcw_state_t, decimal_float, decimal_float);
extern decimal_float (nrcwdf_r)(/*@out@*/ randcw_state_t);
extern decimal_float (urcwdf_r)(/*@out@*/ randcw_state_t);
extern decimal_float (urcw1df_r)(/*@out@*/ randcw_state_t);
extern decimal_float (urcw2df_r)(/*@out@*/ randcw_state_t);
extern decimal_float (urcw3df_r)(/*@out@*/ randcw_state_t);
extern decimal_float (urcw4df_r)(/*@out@*/ randcw_state_t);
extern void (vercwdf_r)(/*@out@*/ randcw_state_t, int, decimal_float []);
extern void (vlrcwdf_r)(/*@out@*/ randcw_state_t, int, decimal_float [], decimal_float, decimal_float);
extern void (vnrcwdf_r)(/*@out@*/ randcw_state_t, int, decimal_float []);
extern void (vurcw1df_r)(/*@out@*/ randcw_state_t, int, decimal_float []);
extern void (vurcw2df_r)(/*@out@*/ randcw_state_t, int, decimal_float []);
extern void (vurcw3df_r)(/*@out@*/ randcw_state_t, int, decimal_float []);
extern void (vurcw4df_r)(/*@out@*/ randcw_state_t, int, decimal_float []);
extern void (vurcwdf_r)(/*@out@*/ randcw_state_t, int, decimal_float []);

extern decimal_double (ercwd)(void);
extern decimal_double (lrcwd)(decimal_double, decimal_double);
extern decimal_double (nrcwd)(void);
extern decimal_double (urcwd)(void);
extern decimal_double (urcw1d)(void);
extern decimal_double (urcw2d)(void);
extern decimal_double (urcw3d)(void);
extern decimal_double (urcw4d)(void);
extern void (vercwd)(int, decimal_double []);
extern void (vlrcwd)(int, decimal_double [], decimal_double, decimal_double);
extern void (vnrcwd)(int, decimal_double []);
extern void (vurcw1d)(int, decimal_double []);
extern void (vurcw2d)(int, decimal_double []);
extern void (vurcw3d)(int, decimal_double []);
extern void (vurcw4d)(int, decimal_double []);
extern void (vurcwd)(int, decimal_double []);

extern decimal_double (ercwd_r)(/*@out@*/ randcw_state_t);
extern decimal_double (lrcwd_r)(/*@out@*/ randcw_state_t, decimal_double, decimal_double);
extern decimal_double (nrcwd_r)(/*@out@*/ randcw_state_t);
extern decimal_double (urcwd_r)(/*@out@*/ randcw_state_t);
extern decimal_double (urcw1d_r)(/*@out@*/ randcw_state_t);
extern decimal_double (urcw2d_r)(/*@out@*/ randcw_state_t);
extern decimal_double (urcw3d_r)(/*@out@*/ randcw_state_t);
extern decimal_double (urcw4d_r)(/*@out@*/ randcw_state_t);
extern void (vercwd_r)(/*@out@*/ randcw_state_t, int, decimal_double []);
extern void (vlrcwd_r)(/*@out@*/ randcw_state_t, int, decimal_double [], decimal_double, decimal_double);
extern void (vnrcwd_r)(/*@out@*/ randcw_state_t, int, decimal_double []);
extern void (vurcw1d_r)(/*@out@*/ randcw_state_t, int, decimal_double []);
extern void (vurcw2d_r)(/*@out@*/ randcw_state_t, int, decimal_double []);
extern void (vurcw3d_r)(/*@out@*/ randcw_state_t, int, decimal_double []);
extern void (vurcw4d_r)(/*@out@*/ randcw_state_t, int, decimal_double []);
extern void (vurcwd_r)(/*@out@*/ randcw_state_t, int, decimal_double []);

#if defined(HAVE_DECIMAL_LONG_DOUBLE)

extern decimal_long_double (ercwdl)(void);
extern decimal_long_double (lrcwdl)(decimal_long_double, decimal_long_double);
extern decimal_long_double (nrcwdl)(void);
extern decimal_long_double (urcwdl)(void);
extern decimal_long_double (urcw1dl)(void);
extern decimal_long_double (urcw2dl)(void);
extern decimal_long_double (urcw3dl)(void);
extern decimal_long_double (urcw4dl)(void);
extern void (vercwdl)(int, decimal_long_double []);
extern void (vlrcwdl)(int, decimal_long_double [], decimal_long_double, decimal_long_double);
extern void (vnrcwdl)(int, decimal_long_double []);
extern void (vurcw1dl)(int, decimal_long_double []);
extern void (vurcw2dl)(int, decimal_long_double []);
extern void (vurcw3dl)(int, decimal_long_double []);
extern void (vurcw4dl)(int, decimal_long_double []);
extern void (vurcwdl)(int, decimal_long_double []);

extern decimal_long_double (ercwdl_r)(/*@out@*/ randcw_state_t);
extern decimal_long_double (lrcwdl_r)(/*@out@*/ randcw_state_t, decimal_long_double, decimal_long_double);
extern decimal_long_double (nrcwdl_r)(/*@out@*/ randcw_state_t);
extern decimal_long_double (urcwdl_r)(/*@out@*/ randcw_state_t);
extern decimal_long_double (urcw1dl_r)(/*@out@*/ randcw_state_t);
extern decimal_long_double (urcw2dl_r)(/*@out@*/ randcw_state_t);
extern decimal_long_double (urcw3dl_r)(/*@out@*/ randcw_state_t);
extern decimal_long_double (urcw4dl_r)(/*@out@*/ randcw_state_t);
extern void (vercwdl_r)(/*@out@*/ randcw_state_t, int, decimal_long_double []);
extern void (vlrcwdl_r)(/*@out@*/ randcw_state_t, int, decimal_long_double [], decimal_long_double, decimal_long_double);
extern void (vnrcwdl_r)(/*@out@*/ randcw_state_t, int, decimal_long_double []);
extern void (vurcw1dl_r)(/*@out@*/ randcw_state_t, int, decimal_long_double []);
extern void (vurcw2dl_r)(/*@out@*/ randcw_state_t, int, decimal_long_double []);
extern void (vurcw3dl_r)(/*@out@*/ randcw_state_t, int, decimal_long_double []);
extern void (vurcw4dl_r)(/*@out@*/ randcw_state_t, int, decimal_long_double []);
extern void (vurcwdl_r)(/*@out@*/ randcw_state_t, int, decimal_long_double []);

#endif /* defined(HAVE_DECIMAL_LONG_DOUBLE) */

#if defined(HAVE_DECIMAL_LONG_LONG_DOUBLE)

extern decimal_long_long_double (ercwdll)(void);
extern decimal_long_long_double (lrcwdll)(decimal_long_long_double, decimal_long_long_double);
extern decimal_long_long_double (nrcwdll)(void);
extern decimal_long_long_double (urcwdll)(void);
extern decimal_long_long_double (urcw1dll)(void);
extern decimal_long_long_double (urcw2dll)(void);
extern decimal_long_long_double (urcw3dll)(void);
extern decimal_long_long_double (urcw4dll)(void);
extern void (vercwdll)(int, decimal_long_long_double []);
extern void (vlrcwdll)(int, decimal_long_long_double [], decimal_long_long_double, decimal_long_long_double);
extern void (vnrcwdll)(int, decimal_long_long_double []);
extern void (vurcw1dll)(int, decimal_long_long_double []);
extern void (vurcw2dll)(int, decimal_long_long_double []);
extern void (vurcw3dll)(int, decimal_long_long_double []);
extern void (vurcw4dll)(int, decimal_long_long_double []);
extern void (vurcwdll)(int, decimal_long_long_double []);

extern decimal_long_long_double (ercwdll_r)(/*@out@*/ randcw_state_t);
extern decimal_long_long_double (lrcwdll_r)(/*@out@*/ randcw_state_t, decimal_long_long_double, decimal_long_long_double);
extern decimal_long_long_double (nrcwdll_r)(/*@out@*/ randcw_state_t);
extern decimal_long_long_double (urcwdll_r)(/*@out@*/ randcw_state_t);
extern decimal_long_long_double (urcw1dll_r)(/*@out@*/ randcw_state_t);
extern decimal_long_long_double (urcw2dll_r)(/*@out@*/ randcw_state_t);
extern decimal_long_long_double (urcw3dll_r)(/*@out@*/ randcw_state_t);
extern decimal_long_long_double (urcw4dll_r)(/*@out@*/ randcw_state_t);
extern void (vercwdll_r)(/*@out@*/ randcw_state_t, int, decimal_long_long_double []);
extern void (vlrcwdll_r)(/*@out@*/ randcw_state_t, int, decimal_long_long_double [], decimal_long_long_double, decimal_long_long_double);
extern void (vnrcwdll_r)(/*@out@*/ randcw_state_t, int, decimal_long_long_double []);
extern void (vurcw1dll_r)(/*@out@*/ randcw_state_t, int, decimal_long_long_double []);
extern void (vurcw2dll_r)(/*@out@*/ randcw_state_t, int, decimal_long_long_double []);
extern void (vurcw3dll_r)(/*@out@*/ randcw_state_t, int, decimal_long_long_double []);
extern void (vurcw4dll_r)(/*@out@*/ randcw_state_t, int, decimal_long_long_double []);
extern void (vurcwdll_r)(/*@out@*/ randcw_state_t, int, decimal_long_long_double []);

#endif	/* defined(HAVE_DECIMAL_LONG_LONG_DOUBLE) */

#endif /* defined(HAVE_DECIMAL) */

#if defined(__cplusplus)
}
#endif

#endif /* !defined(RANDCW_H) */
